/***************************************************************************
*                 _                                _                       *
*                /_\         Chess Board          /_\                      *
*                \_/      -------------------     \_/                      *
*                /_\        Black vs White        /_\                      *
*                |_|      -------------------     |_|                      *
*               /___\      GNU GPL Version 2     /___\                     *
*                                                                          *
***************************************************************************/
/* Header Files */
#include <stdio.h>
#include <stdlib.h>
#include "menu/menu.h"
#include "menu/setting.h"
#include "menu/board.h"
#include "menu/network.h"
/* Define Bool */
#define TRUE 1
#define FALSE 0
/* Define Port */
#define PORT 5799
/* Define Char */
#define E 10
/* Global Definitions */
char chess[E];
char ipad[19];
char white[30];
char black[30];
/* Global Network Definitions */
socket_t tcpsock1;
socket_t tcpsock2; 
socket_t tcpsock;

/*---------------------------------------------------------------------------*/

/* Main Program */
int main(int agec, char **agev)
{ 	
	/* Chess Game Menu */
	while(TRUE) {

	WINDOW **item;
	item=draw_Menu(0);			
	agec=scroll_Menu(item,6,0);		
	delete_Menu(item,6);				
	chess[E] = FALSE;

	switch(agec+1) {

	/* Play White */
	case 1:
	chess[1] = TRUE;		
	displayBoard(chess, white, black);
	break;
					
	/* Play Black */
	case 2:
	chess[2] = TRUE;		
	displayBoard(chess, white, black);	
	break;
		
	/* Empty Board */
	case 3:
	chess[3] = TRUE;	
	displayBoard(chess, white, black);	
	break;
			
	/* Start Server */		
	case 4:
	chess[4]=TRUE;
	settings(ipad, chess, white, black);		
	tcpsock1 = socket(AF_INET, SOCK_STREAM, 0);
	net_bind(&tcpsock1, INADDR_ANY, PORT );
	net_listen(&tcpsock1);	
	while(TRUE)
	{
		net_accept( &tcpsock1, &tcpsock2 );
		displayBoard(chess, white, black);	
		net_close(&tcpsock2);
	}	
	net_close(&tcpsock1);
	break;
			
	/* Start Client */		
	case 5:
	chess[5]=TRUE;
	settings(ipad, chess, white, black);		
	tcpsock = socket(AF_INET, SOCK_STREAM, 0);			
	net_connect(&tcpsock, ipad, PORT);
	displayBoard(chess, white, black);
	net_close(&tcpsock);
	break;

	/* Settings */
	case 6:
	chess[6]=TRUE;
	settings(ipad, chess, white, black);
	break;
			
	}} touchwin(stdscr);
	
	return 0;
}

/*---------------------------------------------------------------------------*/
