/***************************************************************************
*                 _                                _                       *
*                /_\         Chess Board          /_\                      *
*                \_/      -------------------     \_/                      *
*                /_\            Cboard            /_\                      *
*                |_|      -------------------     |_|                      *
*               /___\      GNU GPL Version 2     /___\                     *
*                                                                          *
***************************************************************************/
/* Header Files */
#include "board.h"

static WINDOW *winF;
static WINDOW *winE;
FILE *gnuchess;
const char *cmove = ". ";
const char *emove = ". ... ";

/*---------------------------------------------------------------------------*/

/* Dispaly Chess Board */
void displayBoard(char *chess, char *white, char *black)
{		
	/* Chess Board Array */
	char cb[11][11][2] = {
			
	{{' ',5},{'1',5},{'2',5},{'3',5},{'4',5},{'5',5},{'6',5},{'7',5},{'8',5},{' ',5},{0,0}},
	{{'h',5},{'R',3},{'P',4},{' ',3},{' ',4},{' ',1},{' ',2},{'P',1},{'R',2},{'h',5},{0,0}},
	{{'g',5},{'N',4},{'P',3},{' ',4},{' ',3},{' ',2},{' ',1},{'P',2},{'N',1},{'g',5},{0,0}},
	{{'f',5},{'B',3},{'P',4},{' ',3},{' ',4},{' ',1},{' ',2},{'P',1},{'B',2},{'f',5},{0,0}},
	{{'e',5},{'K',4},{'P',3},{' ',4},{' ',3},{' ',2},{' ',1},{'P',2},{'K',1},{'e',5},{0,0}},
	{{'d',5},{'Q',3},{'P',4},{' ',3},{' ',4},{' ',1},{' ',2},{'P',1},{'Q',2},{'d',5},{0,0}},
	{{'c',5},{'B',4},{'P',3},{' ',4},{' ',3},{' ',2},{' ',1},{'P',2},{'B',1},{'c',5},{0,0}},
	{{'b',5},{'N',3},{'P',4},{' ',3},{' ',4},{' ',1},{' ',2},{'P',1},{'N',2},{'b',5},{0,0}},
	{{'a',5},{'R',4},{'P',3},{' ',4},{' ',3},{' ',2},{' ',1},{'P',2},{'R',1},{'a',5},{0,0}},
	{{' ',5},{'1',5},{'2',5},{'3',5},{'4',5},{'5',5},{'6',5},{'7',5},{'8',5},{' ',5},{0,0}}};
	
	char eb[11][11][2] = {
			
	{{' ',5},{'8',5},{'7',5},{'6',5},{'5',5},{'4',5},{'3',5},{'2',5},{'1',5},{' ',5},{0,0}},
	{{'a',5},{' ',1},{' ',2},{' ',1},{' ',2},{' ',3},{' ',4},{' ',3},{' ',4},{'a',5},{0,0}},
	{{'b',5},{' ',2},{' ',1},{' ',2},{' ',1},{' ',4},{' ',3},{' ',4},{' ',3},{'b',5},{0,0}},
	{{'c',5},{' ',1},{' ',2},{' ',1},{' ',2},{' ',3},{' ',4},{' ',3},{' ',4},{'c',5},{0,0}},
	{{'d',5},{' ',2},{' ',1},{' ',2},{' ',1},{' ',4},{' ',3},{' ',4},{' ',3},{'d',5},{0,0}},
	{{'e',5},{' ',1},{' ',2},{' ',1},{' ',2},{' ',3},{' ',4},{' ',3},{' ',4},{'e',5},{0,0}},
	{{'f',5},{' ',2},{' ',1},{' ',2},{' ',1},{' ',4},{' ',3},{' ',4},{' ',3},{'f',5},{0,0}},
	{{'g',5},{' ',1},{' ',2},{' ',1},{' ',2},{' ',3},{' ',4},{' ',3},{' ',4},{'g',5},{0,0}},
	{{'h',5},{' ',2},{' ',1},{' ',2},{' ',1},{' ',4},{' ',3},{' ',4},{' ',3},{'h',5},{0,0}},
	{{' ',5},{'8',5},{'7',5},{'6',5},{'5',5},{'4',5},{'3',5},{'2',5},{'1',5},{' ',5},{0,0}}};
	
	/*-------------------------------------------------------------------*/
			
	/* Black */
	eb[8][1][0] = 'R';
	eb[7][1][0] = 'N';
	eb[6][1][0] = 'B';
	eb[5][1][0] = 'K';
	eb[4][1][0] = 'Q';
	eb[3][1][0] = 'B';
	eb[2][1][0] = 'N';
	eb[1][1][0] = 'R'; 
	
	eb[8][2][0] = 'P'; 
	eb[7][2][0] = 'P';
	eb[6][2][0] = 'P';
	eb[5][2][0] = 'P';
	eb[4][2][0] = 'P';
	eb[3][2][0] = 'P';
	eb[2][2][0] = 'P';
	eb[1][2][0] = 'P'; 
		
	/* White */
	eb[8][7][0] = 'P'; 
	eb[7][7][0] = 'P';
	eb[6][7][0] = 'P';
	eb[5][7][0] = 'P';
	eb[4][7][0] = 'P';
	eb[3][7][0] = 'P';
	eb[2][7][0] = 'P';
	eb[1][7][0] = 'P';

	eb[8][8][0] = 'R';
	eb[7][8][0] = 'N';
	eb[6][8][0] = 'B';
	eb[5][8][0] = 'K';
	eb[4][8][0] = 'Q';
	eb[3][8][0] = 'B';
	eb[2][8][0] = 'N';
	eb[1][8][0] = 'R';

	/*-------------------------------------------------------------------*/
	
	/* Date */
	strftime(mdate, 75, "%Y.%m.%d", date_Board());
	/* Time and Round */
	engine.btime = 7200;
	engine.wtime = 7200;
	engine.numb = 0;
	engine.count = 2;
	engine.round = 0;
	engine.round++;	
	/* Colors */
	colour_Board();
	/* While Loop */
	while(chess)
	{	
		/*-----------------------------------------------------------*/

		/* Chess Board Core */
		unsigned short int x = 0;
		unsigned short int y = 0;
		unsigned short int z = 2;
		
		move(2,3);
		for(y = 0; y <= HIGH; ++y)
		{	
			move(++z,3);
			for(x = 0; x <= LOW; ++x)
			{	
				attrset(COLOR_PAIR(eb[x][y][1]));
				printw(" %c ", eb[x][y][0]);
			}
			printw("\n");
		}

		/* Bughouse */
		z = 2;
		move(2,47);
		for(y = 0; y <= HIGH; ++y)
		{	
			move(++z,47);
			for(x = 0; x <= LOW; ++x)
			{
				attrset(COLOR_PAIR(cb[x][y][1]));
				printw(" %c ", cb[x][y][0]);
			}
			printw("\n");
		}

		/*-----------------------------------------------------------*/

		/* Player */
		engine.count++;
		if(engine.count % 2)
		{
			player[1] = TRUE;
			player[8] = FALSE;
		}
		else
		{
			player[1] = FALSE;
			player[8] = TRUE;
		}

		/*-----------------------------------------------------------*/

		/* Windows Box */
		attrset(use_default_colors());
		winF = newwin(11,76,13,2);
		box(winF,ACS_VLINE,ACS_HLINE);
		winE = newwin(9,74,14,3);
		scrollok(winE,TRUE);
		/* File Open */
		gnuchess=fopen("/var/log/cboard/engine","r+"); 
		/* Computer */
		while(fread(position,1, sizeof(position),gnuchess))
		{	
			if(chess[2])
			{
				bmove = strstr(position,cmove);
				sscanf(bmove,". %s",nmove);
			}
			if(chess[1])
			{
				bmove = strstr(position,emove);
				sscanf(bmove,". ... %s",nmove);
			}
			wprintw(winE,"%s", position);
		}
		/* Windows Refresh */
		touchwin(stdscr);
		refresh();
		wrefresh(winF);
		wrefresh(winE);
		
		/*-----------------------------------------------------------*/

		/* Time Control */
		engine.start=time(NULL);
		tcpnetwork(nmove,chess,player);		
		engine.diff = difftime(engine.stop=time(NULL),engine.start);
		if(player[1])
		{		
			engine.wtime -= engine.diff;
			engine.horas = ((engine.wtime / 60) / 60);
			engine.minutes = ((engine.wtime / 60) % 60);
			engine.seconds = (engine.wtime % 60);
		}
		else if(player[8])
		{
			engine.btime -= engine.diff;
			engine.horas = ((engine.btime / 60) / 60);
			engine.minutes = ((engine.btime / 60) % 60);
			engine.seconds = (engine.btime % 60);
		}

		/*-----------------------------------------------------------*/
		
		/* a - h | 1 -8 */
		if(((nmove[0] >= 97) && (nmove[0] <= 104)) && 
		((nmove[1] >= 49) && (nmove[1] <= 56)) &&
		((nmove[2] >= 97) && (nmove[2] <= 104)) &&
		((nmove[3] >= 49) && (nmove[3] <= 56)))
		{
			mov1.fxdecimal = nmove[0];
			mov1.fydecimal = nmove[1];
			mov1.txdecimal = nmove[2];
			mov1.tydecimal = nmove[3];
			mov2.fxdecimal = nmove[0];
			mov2.fydecimal = nmove[1];
			mov2.txdecimal = nmove[2];
			mov2.tydecimal = nmove[3];
		}
		else
		{
			chess = 0;
		}
		
		/*-----------------------------------------------------------*/
		
		/* Decimal White Board */
		mov1.fxmove = mov1.fxdecimal - 96;
		mov1.txmove = mov1.txdecimal - 96;
		mov1.fymove = 9 - (mov1.fydecimal - 48);	
		mov1.tymove = 9 - (mov1.tydecimal - 48);
		eb[mov1.txmove][mov1.tymove][0] = 
		eb[mov1.fxmove][mov1.fymove][0];
		eb[mov1.fxmove][mov1.fymove][0] = ' ';
		eb[mov1.txmove][mov1.tymove][1] = 
		eb[mov1.fxmove][mov1.fymove][1];

		/* Board Color */
		mov1.tzmove = mov1.txmove + mov1.tymove;
		
		/* Decimal Black Board */
		mov2.fxmove = 9 - (mov2.fxdecimal - 96);
		mov2.txmove = 9 - (mov2.txdecimal - 96);
		mov2.fymove = mov2.fydecimal - 48;	
		mov2.tymove = mov2.tydecimal - 48;
		cb[mov2.txmove][mov2.tymove][0] = 
		cb[mov2.fxmove][mov2.fymove][0];
		cb[mov2.fxmove][mov2.fymove][0] = ' '; 
		cb[mov2.txmove][mov2.tymove][1] = 
		cb[mov2.fxmove][mov2.fymove][1];

		/* Board Color */					
		if(mov1.tzmove % 2)
		{
			/* White Cyan */
			if(player[1]){
			eb[mov1.txmove][mov1.tymove][1] = 4;
			cb[mov2.txmove][mov2.tymove][1] = 4;}			
			/* Red Cyan */
			else if(player[8]){
			eb[mov1.txmove][mov1.tymove][1] = 2;
			cb[mov2.txmove][mov2.tymove][1] = 2;}
		}
		else
		{
			/* White Blue */
			if(player[1]){
			eb[mov1.txmove][mov1.tymove][1] = 3;
			cb[mov2.txmove][mov2.tymove][1] = 3;}
			/* Red Blue */
			else if(player[8]){
			eb[mov1.txmove][mov1.tymove][1] = 1;
			cb[mov2.txmove][mov2.tymove][1] = 1;}
		}

		/*-----------------------------------------------------------*/

		/* Show Move Message */
		mvhline(0,0,ACS_HLINE,100);
		mvhline(2,0,ACS_HLINE,100);
		move(1,1);

		if(player[1])
		{
			++engine.numb;
			printw(" %2d.%c%c",
			engine.numb,mov1.fxdecimal,mov1.fydecimal);
			printw("/%c%c ",mov1.txdecimal,mov1.tydecimal);
			printw("\t\t %02d:%02d:%02d",
			engine.horas,engine.minutes,engine.seconds);
			printw("\t\t%s", white);
		}
		else if(player[8])
		{
			printw(" %2d.%c%c",
			engine.numb,mov1.fxdecimal,mov1.fydecimal);
			printw("/%c%c ",mov1.txdecimal,mov1.tydecimal);
			printw("\t\t %02d:%02d:%02d",
			engine.horas,engine.minutes,engine.seconds);
			printw("\t\t%s", black);
		}
	}
	/* File Closed */
	fclose(gnuchess);
	endwin();
	clear(); 
}

/*---------------------------------------------------------------------------*/

