/***************************************************************************
*                 _                                _                       *
*                /_\         Chess Board          /_\                      *
*                \_/      -------------------     \_/                      *
*                /_\            Cboard            /_\                      *
*                |_|      -------------------     |_|                      *
*               /___\      GNU GPL Version 2     /___\                     *
*                                                                          *
***************************************************************************/
#ifndef BOARD_H_
#define BOARD_H_
/* Header Files */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <curses.h>
#include "cbtime.h"
#include "colour.h"
#include "network.h"
#include "move.h"
/* Define Bool */
#define TRUE 1
#define FALSE 0
/* Define Array */
#define HIGH 9
#define LOW 9
/* Define Buffer */
#define MOV 16
#define BUF 2048
/* Define Char */
#define C 10
/* Define Date */
#define DATE 75

/*---------------------------------------------------------------------------*/

/* Move */
char mdate[DATE];
char nmove[MOV];
char position[BUF];
char *bmove;
/* Player */
char player[C];

/* Class Engine */
struct uciEngine
{
	/* Time */
	signed int btime;
	signed int wtime;
	unsigned int round;
	unsigned short int numb;
	unsigned short int count;
	/* Clock */
	double diff;
	signed int horas;
	signed int minutes; 
	signed int seconds;
	time_t start;
	time_t stop;

}engine;

/*---------------------------------------------------------------------------*/

/* Class Move */
struct uciMove
{
	/* Move */
	char fxdecimal;
	char fydecimal;
	char txdecimal;
	char tydecimal;
	unsigned short int fxmove;
	unsigned short int txmove;
	unsigned short int fymove;
	unsigned short int tymove;
	unsigned short int tzmove;
}mov1, mov2;

/*---------------------------------------------------------------------------*/

/* Function */
void displayBoard(char *chess, char *white, char *black);

/*---------------------------------------------------------------------------*/

#endif


