/***************************************************************************
*                 _                                _                       *
*                /_\         Chess Board          /_\                      *
*                \_/      -------------------     \_/                      *
*                /_\             Menu             /_\                      *
*                |_|      -------------------     |_|                      *
*               /___\     GNU GPL Version 2      /___\                     *
*                                                                          *
***************************************************************************/
/* Header Files */
#include "menu.h"

/* Window */
WINDOW **item;
float ver, hor;
float ve, ho;

//-----------------------------------------------------------------------------

/* Delete Menu */
void Menu::delete_Menu(WINDOW **item,int count)
{
	int it;
	for( it = 0; it < count; it++)
	{
		delwin(item[it]);
	}
	clear();
	refresh();
	free(item);
}

//-----------------------------------------------------------------------------

/* Draw Menu */
WINDOW** Menu::draw_Menu(int start_col)
{
	/* Chess Board Menu */
	initscr();
	bkgd(use_default_colors());
	item = (WINDOW **)calloc(9, sizeof(WINDOW *));
	getmaxyx(stdscr, ve, ho);

	ver = (ve/4);
	hor = (ho/3.5);

	item[0] = newwin(13,36,ver,hor);
	box(item[0],ACS_VLINE,ACS_HLINE);
	wbkgd(item[0],use_default_colors());
	mvwhline(item[0],2,1,ACS_HLINE,34);
	item[1] = subwin(item[0],1,30,ver+3,hor+3);
	item[2] = subwin(item[0],1,30,ver+4,hor+3);
	mvwhline(item[0],5,1,ACS_HLINE,34);
	item[3] = subwin(item[0],1,30,ver+6,hor+3);
	mvwhline(item[0],7,1,ACS_HLINE,34);
	item[4] = subwin(item[0],1,30,ver+8,hor+3);
	item[5] = subwin(item[0],1,30,ver+9,hor+3);
	mvwhline(item[0],10,1,ACS_HLINE,34);
	item[6] = subwin(item[0],1,30,ver+11,hor+3);
	
	wattrset(item[0],A_BOLD);
	mvwprintw(item[0], 1, 9, "<<< CHESS BOARD >>>");
	wattrset(item[0], A_NORMAL);
	mvwprintw(item[0],3, 4,"Play White                 W");
	mvwprintw(item[0],4, 4,"Play Black                 B");
	mvwprintw(item[0],6, 4,"Empty Board                E");
	mvwprintw(item[0],8, 4,"Start Server               S");
	mvwprintw(item[0],9, 4,"Start Client               C");
	mvwprintw(item[0],11,4,"Settings                   G");
	wattrset(item[0],A_BOLD);
	mvwprintw(item[0],3, 9, "W");
	mvwprintw(item[0],4, 9, "B");
	mvwprintw(item[0],6, 4, "E");
	mvwprintw(item[0],8,10, "S");
	mvwprintw(item[0],9,10, "C");
	mvwprintw(item[0],11,4, "S");
	
	refresh();
	wrefresh(item[0]);
	curs_set(0);
	keypad(stdscr,1);	

	return item;
}

//-----------------------------------------------------------------------------

/* Scroll Menu */
int Menu::scroll_Menu(WINDOW **item,int count,int menu_start_col)
{	
	int selected = 0;

	while(true) 
	{
		switch(getch())
		{
			case KEY_DOWN:
			wbkgd(item[selected+1],use_default_colors());
			wattrset(item[0],A_BOLD);
			mvwprintw(item[0],3, 9, "W");
			mvwprintw(item[0],4, 9, "B");
			mvwprintw(item[0],6, 4, "E");
			mvwprintw(item[0],8,10, "S");
			mvwprintw(item[0],9,10, "C");
			mvwprintw(item[0],11,4, "S");
			wnoutrefresh(item[selected+1]); 
			selected=(selected+count+1) % count; 
			wbkgd(item[selected+1],A_REVERSE |A_BOLD);
			wnoutrefresh(item[selected+1]);
			doupdate();	
			break;
			 
			case KEY_UP:
			wbkgd(item[selected+1],use_default_colors());
			wattrset(item[0],A_BOLD);
			mvwprintw(item[0],3, 9, "W");
			mvwprintw(item[0],4, 9, "B");
			mvwprintw(item[0],6, 4, "E");
			mvwprintw(item[0],8,10, "S");
			mvwprintw(item[0],9,10, "C");
			mvwprintw(item[0],11,4, "S");
			wnoutrefresh(item[selected+1]); 
			selected=(selected+count-1) % count; 
			wbkgd(item[selected+1],A_REVERSE |A_BOLD);
			wnoutrefresh(item[selected+1]);
			doupdate();
			break;
			
			case ESCAPE: 
			return -1;
			break;
			
			case ENTER: 
			return selected;
			break;
			
			case XW:
			selected = 0;
			return selected;
			break;
			
			case XB:
			selected = 1;
			return selected;
			break;
			
			case XE:
			selected = 2;
			return selected;
			break;

			case XS:
			selected = 3;
			return selected;
			break;
			
			case XC:
			selected = 4;
			return selected;
			break;
			
			case XG:
			selected = 5;
			return selected;
			break;
		}
	}
}

//-----------------------------------------------------------------------------

